/*
 * Fachlicher Schlüssel für JPA Entität
 */
package de.ivu.elect.business.wahlausschuss.entity;

import de.ivu.elect.jee.faces.Messages;
import de.ivu.elect.jee.faces.IMessages;
import java.util.function.Function;

@javax.enterprise.inject.Vetoed
public class WahlausschussEntschaedigungTK
implements de.ivu.elect.jee.entity.tk.EntityTK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

  private final int hashCode;

    protected final de.ivu.elect.business.wahlausschuss.entity.Wahlausschussrolle wahlausschussrolle;
    public de.ivu.elect.business.wahlausschuss.entity.Wahlausschussrolle getWahlausschussrolle(){
      return wahlausschussrolle;
    }

  public WahlausschussEntschaedigungTK(
de.ivu.elect.business.wahlausschuss.entity.Wahlausschussrolle wahlausschussrolle
  ) {
    super();


      this.wahlausschussrolle = wahlausschussrolle;
    
hashCode = calculateHashCode();
  }

  @Override
  public int hashCode(){
    return hashCode;
  }


  protected int calculateHashCode() {
        int result = 1;
    
    
                    result = result + ((wahlausschussrolle == null) ? 0 : wahlausschussrolle.hashCode());
        
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    if (hashCode()!=obj.hashCode()) {
      return false;
    }


            
    if (getClass() != obj.getClass()) {
      if (!(obj instanceof WahlausschussEntschaedigungTK)) {
        return false;
      }

      if (!obj.getClass().isInstance(this)) {
        return obj.equals(this); // equals-Methode aus speziellerer Klasse verwenden
      }

    }

        WahlausschussEntschaedigungTK other = (WahlausschussEntschaedigungTK) obj;

                if (wahlausschussrolle == null) {
          if (other.wahlausschussrolle != null) {
            return false;
          }
        } else if (!wahlausschussrolle.equals(other.wahlausschussrolle)) {
          return false;
        }
        
            return true;
    
  }

  protected boolean hatAttribute() {
        return true;
      }

  @Override
  public String getEntityMessageKey() {
    return WahlausschussEntschaedigungConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(WahlausschussEntschaedigungConstants.MESSAGE_KEY_ENTITY_EINZAHL, WahlausschussEntschaedigungConstants.MESSAGE_KEY_WAHLAUSSCHUSSROLLE_EINZAHL, wahlausschussrolle));
        
        return result;
      }


            @Override
            public String toString() {
            return "WahlausschussEntschaedigungTK[" + toStringParameter() + "]";
            }



            protected String toStringParameter() {
            String result = ""

                                        +"wahlausschussrolle="+wahlausschussrolle
                        
            ;
                            return result;
            
            }

  @Override
  public String toStringLokalisiert(IMessages messages) {
    return messages.getMessageForMessageKey(getEntityMessageKey()) + " ["
            + toStringLokalisiertFields(messages)
            + "]"
            ;
   }

            protected String toStringLokalisiertFields(IMessages messages) {
        return ""
                                      + messages.getMessageForMessageKey(WahlausschussEntschaedigungConstants.MESSAGE_KEY_WAHLAUSSCHUSSROLLE_EINZAHL) + "=" +

                                  messages.lokalisiere(wahlausschussrolle)
                
                                             ;
      }


            private String toStringLokalisiert(de.ivu.elect.jee.entity.tk.EntityTK entityTK, IMessages messages) {
                if (entityTK != null) {
                    return entityTK.toStringLokalisiert(messages);
                }
                return null;
            }

            public static <E extends WahlausschussEntschaedigung> java.util.Map<WahlausschussEntschaedigungTK, E> mappeWahlausschussEntschaedigungNachTK(java.util.Collection<E> entities) {
                return entities.stream().collect(java.util.stream.Collectors.toMap(WahlausschussEntschaedigung::getWahlausschussEntschaedigungTK, Function.<E>identity(), (u,v)-> v));
                }


                public static Function<WahlausschussEntschaedigung, WahlausschussEntschaedigungTK> getWahlausschussEntschaedigungToTKFunction() {
                return WahlausschussEntschaedigung::getWahlausschussEntschaedigungTK;
                }

}
